"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateMethod = (obj, member, method) => {
  __accessCheck(obj, member, "access private method");
  return method;
};

// src/index.ts
var src_exports = {};
__export(src_exports, {
  AbstractCrudService: () => abstractCrud_service_default
});
module.exports = __toCommonJS(src_exports);

// src/services/cruds/dynamodb/dynamoDbCrud.service.ts
var import_qrvey_id_generator = require("qrvey-id-generator");

// src/services/cruds/dynamodb/dynamoDbClient.service.ts
var import_client_dynamodb = require("@aws-sdk/client-dynamodb");
var import_lib_dynamodb = require("@aws-sdk/lib-dynamodb");
var AWS_REGION = process.env.AWS_DEFAULT_REGION;
var DynamoDbClientService = class {
  constructor(tableName) {
    if (!tableName)
      throw new Error(
        'The "tableName" is required to use a DynamoDbClientService.'
      );
    this.tableName = tableName;
    const client = new import_client_dynamodb.DynamoDBClient({ region: AWS_REGION });
    this.dynamoDBClient = import_lib_dynamodb.DynamoDBDocumentClient.from(client, {
      marshallOptions: {
        removeUndefinedValues: true
      }
    });
  }
  /**
   * Get an item by key
   * @param {Object} keyObject - Ex: { jobId: 1234 }
   * @param {GetCommandInput} options
   */
  async getByKey(keyObject, options = {}) {
    const params = __spreadValues({
      TableName: this.tableName,
      Key: keyObject
    }, options);
    const result = await this.dynamoDBClient.send(new import_lib_dynamodb.GetCommand(params));
    return result.Item;
  }
  /**
   * Query a table
   * @param {QueryCommandInput} options
   */
  async query(options = {}) {
    const params = __spreadValues({
      TableName: this.tableName
    }, options);
    const result = await this.dynamoDBClient.send(new import_lib_dynamodb.QueryCommand(params));
    if (result.$metadata)
      delete result.$metadata;
    return result;
  }
  /**
   * Create/Replace a item object
   * To take care:
   * - https://stackoverflow.com/questions/43667229/difference-between-dynamodb-putitem-vs-updateitem
   * @param {Object} input
   */
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  async put(input) {
    const params = {
      TableName: this.tableName,
      Item: input,
      ReturnValues: "NONE"
    };
    return await this.dynamoDBClient.send(new import_lib_dynamodb.PutCommand(params));
  }
  /**
   * Update a item object
   * To take care:
   * - https://stackoverflow.com/questions/43667229/difference-between-dynamodb-putitem-vs-updateitem
   * @param {Object} keyObject - Ex: { jobId: 1234 }
   * @param {UpdateCommandInput} updateObject
   */
  async update(keyObject, options = {}) {
    const params = __spreadValues({
      TableName: this.tableName,
      Key: keyObject,
      ReturnValues: "NONE"
    }, options);
    return await this.dynamoDBClient.send(new import_lib_dynamodb.UpdateCommand(params));
  }
  /**
   * Delete/Remove an item object
   */
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  async remove(keyObject) {
    const params = {
      TableName: this.tableName,
      Key: keyObject,
      ReturnValues: "NONE"
    };
    return await this.dynamoDBClient.send(new import_lib_dynamodb.DeleteCommand(params));
  }
};

// src/services/cruds/dynamodb/queryBuilderCondition.service.ts
var QueryBuilderConditionService = class {
  constructor(query) {
    this.tempKey = "";
    this.wheres = [];
    this.filters = [];
    this.updates = [];
    this.attributeNames = {};
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    this.attributeValues = {};
    this.query = query;
    this.command = {};
  }
  get() {
    this.build();
    return this.command;
  }
  setKey(key) {
    this.tempKey = key;
    return this;
  }
  from(methodName) {
    this.queryFrom = methodName;
    return this;
  }
  eq(keyValue) {
    const { key, value } = this.generateKeyValue(keyValue);
    const expression = `${key} = ${value}`;
    this.setExpression(expression);
    return this.query;
  }
  contains(keyValue) {
    const { key, value } = this.generateKeyValue(keyValue);
    const expression = `contains(${key}, ${value})`;
    this.setExpression(expression);
    return this.query;
  }
  beginsWith(keyValue) {
    const { key, value } = this.generateKeyValue(keyValue);
    const expression = `begins_with(${key}, ${value})`;
    this.setExpression(expression);
    return this.query;
  }
  project(keyValue) {
    const key = `#${keyValue}`;
    this.attributeNames[key] = keyValue;
    return key;
  }
  setExpression(expression) {
    switch (this.queryFrom) {
      case "filter" /* filter */:
        this.filters.push(expression);
        break;
      case "update" /* update */:
        this.updates.push(expression);
        break;
      default:
        this.wheres.push(expression);
        break;
    }
  }
  generateKeyValue(value) {
    const keyExpression = `#${this.tempKey}1`;
    const valueExpression = `:${this.tempKey}1`;
    this.attributeNames[keyExpression] = this.tempKey;
    this.attributeValues[valueExpression] = value;
    return { key: keyExpression, value: valueExpression };
  }
  build() {
    if (this.wheres.length > 0) {
      const keyConditionExpression = this.wheres.join(" AND ");
      this.command["KeyConditionExpression"] = keyConditionExpression;
    }
    if (this.filters.length > 0) {
      const filterExpression = this.filters.join(" AND ");
      this.command["FilterExpression"] = filterExpression;
    }
    if (this.updates.length > 0) {
      const filterExpression = this.updates.join(", ");
      this.command["UpdateExpression"] = `SET ${filterExpression}`;
    }
    if (Object.values(this.attributeNames).length > 0)
      this.command["ExpressionAttributeNames"] = this.attributeNames;
    if (Object.values(this.attributeValues).length > 0)
      this.command["ExpressionAttributeValues"] = this.attributeValues;
  }
};

// src/services/cruds/dynamodb/queryBuilder.service.ts
var QueryBuilderService = class {
  constructor() {
    this.command = {};
    this.condition = new QueryBuilderConditionService(this);
  }
  get() {
    const condition = this.condition.get();
    return __spreadValues(__spreadValues({}, this.command), condition);
  }
  limit(num) {
    this.command.Limit = num;
    return this;
  }
  usingIndex(indexName) {
    this.command.IndexName = indexName;
    return this;
  }
  ascending() {
    this.command.ScanIndexForward = true;
    return this;
  }
  descending() {
    this.command.ScanIndexForward = false;
    return this;
  }
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  startKey(lastEvaluatedKey) {
    this.command.ExclusiveStartKey = lastEvaluatedKey;
    return this;
  }
  projection(fields) {
    const expression = [];
    fields.forEach((field) => {
      const key = this.condition.project(field);
      expression.push(key);
    });
    this.command.ProjectionExpression = expression.join(",");
    return this;
  }
  where(keyName) {
    this.condition.setKey(keyName).from("where" /* where */);
    return this.condition;
  }
  filter(keyName) {
    this.condition.setKey(keyName).from("filter" /* filter */);
    return this.condition;
  }
  update(attribute) {
    for (const [key, value] of Object.entries(attribute)) {
      this.condition.setKey(key).from("update" /* update */);
      this.condition.eq(value);
    }
    return this;
  }
};

// src/utils/constants.ts
var FILTER_OPERATOR_MAP = {
  CONTAINS: "contains",
  EQUAL: "eq",
  STARTS_WITH: "beginsWith"
};
var DYNAMODB_OPERATORS = {
  EQUAL: "EQUAL"
};

// src/services/cruds/dynamodb/dynamoDbCrud.service.ts
var _applyWhereFilter, applyWhereFilter_fn, _applyFilterFilter, applyFilterFilter_fn, _applyFilters, applyFilters_fn, _applySorting, applySorting_fn, _fetchResults, fetchResults_fn;
var DynamoDbCrudService = class {
  constructor(tableName, idColumnName = "id", partitionKey = null) {
    __privateAdd(this, _applyWhereFilter);
    __privateAdd(this, _applyFilterFilter);
    __privateAdd(this, _applyFilters);
    __privateAdd(this, _applySorting);
    __privateAdd(this, _fetchResults);
    this.dynamoDbClientService = new DynamoDbClientService(tableName);
    this.tableName = tableName;
    this.idColumnName = idColumnName;
    this.partitionKey = partitionKey;
  }
  async create(entity) {
    var _a;
    const id = ((_a = entity[this.idColumnName]) == null ? void 0 : _a.toString()) || (0, import_qrvey_id_generator.getId)();
    const body = __spreadProps(__spreadValues({}, entity), { [this.idColumnName]: id });
    await this.dynamoDbClientService.put(body);
    return body;
  }
  async findById(filters) {
    var _a;
    const query = new QueryBuilderService();
    __privateMethod(this, _applyFilters, applyFilters_fn).call(this, query, filters);
    query.limit(1);
    const command = query.get();
    const result = await this.dynamoDbClientService.query(command);
    if ((result == null ? void 0 : result.Items) && ((_a = result.Items) == null ? void 0 : _a.length) > 0) {
      return result.Items[0];
    }
    throw new Error("NOT_FOUND");
  }
  isNotEmptyObject(obj) {
    return obj !== null && typeof obj === "object" && Object.keys(obj).length > 0;
  }
  find(filters, options = {}) {
    const query = new QueryBuilderService();
    if (options.limit)
      query.limit(options.limit);
    if (options.indexName)
      query.usingIndex(options.indexName);
    __privateMethod(this, _applyFilters, applyFilters_fn).call(this, query, filters);
    __privateMethod(this, _applySorting, applySorting_fn).call(this, query, options.sorting, options.sortIndexes);
    return __privateMethod(this, _fetchResults, fetchResults_fn).call(this, query.get(), options.limit);
  }
  async update(filters, data) {
    const savedRecord = await this.findById(filters);
    const newData = __spreadValues(__spreadValues({}, savedRecord), data);
    if (this.partitionKey)
      newData[this.partitionKey] = savedRecord[this.partitionKey];
    newData[this.idColumnName] = savedRecord[this.idColumnName];
    await this.dynamoDbClientService.put(newData);
    return newData;
  }
  async remove(filters) {
    const key = filters.reduce((obj, item) => {
      const property = item.attribute;
      obj[property] = item.value;
      return obj;
    }, {});
    await this.dynamoDbClientService.remove(key);
  }
};
_applyWhereFilter = new WeakSet();
applyWhereFilter_fn = function(query, filter) {
  var _a;
  const operator = FILTER_OPERATOR_MAP[(_a = filter.operator) != null ? _a : DYNAMODB_OPERATORS.EQUAL];
  query.where(filter.attribute)[operator](filter.value);
};
_applyFilterFilter = new WeakSet();
applyFilterFilter_fn = function(query, filter) {
  var _a;
  const operator = FILTER_OPERATOR_MAP[(_a = filter.operator) != null ? _a : DYNAMODB_OPERATORS.EQUAL];
  query.filter(filter.attribute)[operator](filter.value);
};
_applyFilters = new WeakSet();
applyFilters_fn = function(query, filters) {
  if (typeof filters === "string" && this.partitionKey) {
    query.filter(this.partitionKey)[DYNAMODB_OPERATORS.EQUAL](
      filters
    );
  } else if (Array.isArray(filters)) {
    filters.forEach((filter) => {
      const isWhereProperty = [
        this.partitionKey,
        this.idColumnName
      ].includes(filter.attribute);
      isWhereProperty ? __privateMethod(this, _applyWhereFilter, applyWhereFilter_fn).call(this, query, filter) : __privateMethod(this, _applyFilterFilter, applyFilterFilter_fn).call(this, query, filter);
    });
  }
};
_applySorting = new WeakSet();
applySorting_fn = function(query, sorting, sortIndexes) {
  if (sorting) {
    const { field, direction } = sorting;
    const sortIndex = sortIndexes.find(
      (sortIndex2) => sortIndex2.field === field
    );
    if (sortIndex) {
      query.usingIndex(sortIndex.index);
      if (direction === "DESC") {
        query.descending();
      } else {
        query.ascending();
      }
    }
  }
};
_fetchResults = new WeakSet();
fetchResults_fn = async function(command, limit) {
  var _a, _b, _c, _d, _e;
  let results = [];
  let LastEvaluatedKey = {};
  do {
    if (this.isNotEmptyObject(LastEvaluatedKey))
      command.ExclusiveStartKey = LastEvaluatedKey;
    const result = await this.dynamoDbClientService.query(command);
    command.Limit = ((_a = command.Limit) != null ? _a : 0) - ((_c = (_b = result.Items) == null ? void 0 : _b.length) != null ? _c : 0);
    results = (_d = result.Items) != null ? _d : [];
    LastEvaluatedKey = (_e = result.LastEvaluatedKey) != null ? _e : {};
  } while (results.length < limit && this.isNotEmptyObject(LastEvaluatedKey));
  const lastEvaluatedKey = this.isNotEmptyObject(LastEvaluatedKey) ? Buffer.from(JSON.stringify(LastEvaluatedKey)).toString("base64") : null;
  return { items: results, lastEvaluatedKey };
};

// src/services/cruds/postgresql/postgreSqlCrud.service.ts
var import_qrvey_id_generator2 = require("qrvey-id-generator");

// src/services/cruds/postgresql/postgreSqlClient.service.ts
var import_pg_format = __toESM(require("pg-format"));

// src/services/cruds/postgresql/query.service.ts
var import_pg = require("pg");
var _QueryService = class _QueryService {
  static getConnectionString() {
    return process.env.PG_CONNECTION_STRING || null;
  }
  static async openConnection() {
    if (_QueryService.client)
      return;
    const connectionSettings = {};
    const connectionString = _QueryService.getConnectionString();
    if (connectionString) {
      connectionSettings.connectionString = connectionString;
    }
    _QueryService.client = new import_pg.Client(connectionSettings);
    return _QueryService.client.connect().catch((error) => {
      console.log("[Postgresql-Client] Connection Failed:", error);
      throw error;
    });
  }
  static async executeQuery(queryText, values) {
    await _QueryService.openConnection();
    if (!_QueryService.client) {
      throw new Error("[Postgresql-Client] Connection not found.");
    }
    try {
      const result = await _QueryService.client.query(queryText, values);
      return result;
    } catch (error) {
      console.log("[Postgresql-Client] Query Execution Failed:", error);
      throw error;
    }
  }
  static closeConnection() {
    if (_QueryService.client) {
      _QueryService.client.end();
    }
  }
};
_QueryService.client = null;
var QueryService = _QueryService;

// src/services/cruds/postgresql/postgreSqlClient.service.ts
var PostgresqlClientService = class {
  buildFilterClause(filters, logicOperator) {
    const filterClauses = filters.map((filter) => {
      if ("attribute" in filter) {
        return `${import_pg_format.default.ident(filter.attribute)} ${filter.operator} ${import_pg_format.default.literal(filter.value)}`;
      } else {
        return `(${this.buildFilterClause(
          filter.filters,
          filter.logicOperator
        )})`;
      }
    });
    const operator = logicOperator != null ? logicOperator : "AND" /* AND */;
    return filterClauses.join(` ${operator} `);
  }
  buildQueryFilters(filterExpressions) {
    if (!(filterExpressions == null ? void 0 : filterExpressions.filters))
      return;
    const filterClause = this.buildFilterClause(
      filterExpressions == null ? void 0 : filterExpressions.filters,
      filterExpressions == null ? void 0 : filterExpressions.logicOperator
    );
    return filterClause;
  }
  formatOrderByItem(item) {
    if (typeof item === "string") {
      return import_pg_format.default.ident(item);
    } else if (typeof item === "object" && item !== null) {
      const [column, orientation] = Object.entries(item)[0];
      return `${import_pg_format.default.ident(column)} ${orientation.toUpperCase()}`;
    } else {
      throw new Error();
    }
  }
  buildOrderByClause(orderBy) {
    try {
      return orderBy.map(this.formatOrderByItem).join(", ");
    } catch (error) {
      return "";
    }
  }
  async createCommand(tableName, data) {
    const keys = Object.keys(data);
    const values = Object.values(data);
    const query = (0, import_pg_format.default)(
      `INSERT INTO %I (%I) VALUES (%L) RETURNING *;`,
      tableName,
      keys,
      values
    );
    return QueryService.executeQuery(query);
  }
  addFiltersToQuery(query, filters) {
    if (filters)
      query += ` WHERE ${this.buildQueryFilters(filters)}`;
    return query;
  }
  addOrderByToQuery(query, orderBy) {
    if (orderBy)
      query += ` ORDER BY ${this.buildOrderByClause(orderBy)}`;
    return query;
  }
  addPaginationToQuery(query, pagination) {
    if (pagination) {
      const { limit, from } = pagination;
      if (limit)
        query += ` LIMIT ${limit}`;
      if (from)
        query += ` OFFSET ${from}`;
    }
    return query;
  }
  async findCommand(tableName, options) {
    let query = `SELECT * FROM ${import_pg_format.default.ident(tableName)}`;
    query = this.addFiltersToQuery(query, options == null ? void 0 : options.filters);
    query = this.addOrderByToQuery(query, options == null ? void 0 : options.orderBy);
    query = this.addPaginationToQuery(query, options == null ? void 0 : options.pagination);
    return QueryService.executeQuery(query);
  }
  async updateCommand(tableName, filters, data) {
    let query = `UPDATE ${import_pg_format.default.ident(tableName)} SET`;
    const updateClauses = Object.entries(data).map(([key, value]) => {
      return `${import_pg_format.default.ident(key)} = ${import_pg_format.default.literal(value)}`;
    });
    query += ` ${updateClauses.join(", ")}`;
    query += " WHERE ";
    query += this.buildFilterClause(filters.filters, filters.logicOperator);
    return QueryService.executeQuery(query);
  }
  async deleteCommand(tableName, filters) {
    let query = `DELETE FROM ${import_pg_format.default.ident(tableName)}`;
    if (filters) {
      query += " WHERE ";
      query += this.buildFilterClause(
        filters.filters,
        filters.logicOperator
      );
    }
    return QueryService.executeQuery(query);
  }
};

// src/services/cruds/postgresql/postgreSqlCrud.service.ts
var PostgreSqlCrudService = class extends PostgresqlClientService {
  constructor(tableName, idColumnName = "id", partitionKey = null) {
    super();
    this.tableName = tableName;
    this.idColumnName = idColumnName;
    this.partitionKey = partitionKey;
  }
  async create(entity) {
    var _a;
    const id = ((_a = entity[this.idColumnName]) == null ? void 0 : _a.toString()) || (0, import_qrvey_id_generator2.getId)();
    const body = __spreadProps(__spreadValues({}, entity), { [this.idColumnName]: id });
    return this.createQuery(this.tableName, body).then(
      (data) => data == null ? void 0 : data.rows
    );
  }
  async find(findOptions) {
    return this.findQuery(this.tableName, findOptions).then(
      (data) => data == null ? void 0 : data.rows
    );
  }
  async findById(findOptions) {
    return this.findQuery(this.tableName, findOptions).then(
      (data) => (data == null ? void 0 : data.rows[0]) ? data == null ? void 0 : data.rows[0] : null
    );
  }
  update(filters, data) {
    return this.updateQuery(
      this.tableName,
      filters,
      data
    );
  }
  async remove(filters) {
    await this.deleteQuery(this.tableName, filters);
  }
  runQuery(querySentence, values) {
    super.query(querySentence, values);
  }
};

// src/services/crud.service.ts
var CrudFactory = class {
  static databaseClientService(tableName, idColumnName, partitionKey = null) {
    var _a;
    const multiCloudDatabase = ((_a = process.env.RUNTIME_ENV) == null ? void 0 : _a.toLowerCase()) === "MULTI_PLATFORM";
    if (multiCloudDatabase)
      return new PostgreSqlCrudService(
        tableName,
        idColumnName,
        partitionKey
      );
    return new DynamoDbCrudService(
      tableName,
      idColumnName,
      partitionKey
    );
  }
};

// src/services/abstractCrud.service.ts
var AbstractCrudService = class {
  constructor(tableName, idColumnName = "id", partitionKey = null) {
    this.crudService = CrudFactory.databaseClientService(
      tableName,
      idColumnName,
      partitionKey
    );
  }
  create(entity) {
    return this.crudService.create(entity);
  }
  find(filters = {}) {
    return this.crudService.find(filters);
  }
  findById(filters) {
    return this.crudService.findById(filters);
  }
  update(filters, data) {
    return this.crudService.update(filters, data);
  }
  remove(filters) {
    return this.crudService.remove(filters);
  }
};
var abstractCrud_service_default = AbstractCrudService;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AbstractCrudService
});
//# sourceMappingURL=index.js.map